﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace GraphBundling2D
{
    class Vertex
    {
        #region Attributes
        // X component of the 3D view
        private double X;
        // Y component of the 3D view
        private double Y;
        // Z component of the 3D view
        private double Z;
        // Color of the point
        private Color color;
        #endregion

        #region Constructors
        public Vertex(double x, double y, double z)
        {
            this.X = x;
            this.Y = y;
            this.Z = z;
            this.color = new Color();
            this.color = Color.FromArgb(255, 0, 0, 0);
        }

        public Vertex(double x, double y, double z, Color col)
        {
            this.X = x;
            this.Y = y;
            this.Z = z;
            this.color = col;
        }
        #endregion

        #region Clone
        public static Vertex CloneVertex(Vertex vertex)
        {
            return new Vertex(vertex.getX(), vertex.getY(), vertex.getZ(), vertex.getColor());
        }
        #endregion

        #region Getters and Setters
        public double getX()
        {
            return this.X;
        }

        public double getY()
        {
            return this.Y;
        }

        public double getZ()
        {
            return this.Z;
        }

        public Color getColor()
        {
            return this.color;
        }

        public void setX(double x)
        {
            this.X = x;
        }

        public void setY(double y)
        {
            this.Y = y;
        }

        public void setZ(double z)
        {
            this.Z = z;
        }

        public void setColor(Color c)
        {
            this.color = c;
        }
        #endregion

        #region Equals
        public bool Equals(Vertex vert)
        {
            if (this.X == vert.getX() && this.Y == vert.getY() && this.Z == vert.getZ() && this.color == vert.getColor())
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        #endregion
    }
}